function z = znkBasisOSADVec(p, r, phi, strf),

% ZNKBASISOSADVEC Vector of Zernikie (OSA) terms 
%
% ZNKBASISOSADVEC(p, r, phi, strf). The Zernike object and polar 
% co-ordinate (r, phi) as well as the derivative.
%
% NOTE : 
% matrix where N rows are terms for each (r_i, phi_i) (i = 1 ... N)
% and the columns are for the M terms (j = 1 ... M) 
%
%

% added matrix return capability

r   = r(:);
phi = phi(:);

 
if (size(p,1) > 66),
   for l=1:size(p,1),
       z(:,l) = znkBasisOSADv(r, phi, p(l,1), p(l,2), strf);
   end
else
   z = znkQuickBasis(r, phi, size(p,1)-1, strf);
end

%   e = abs(z-z0);
%   if (max(e(:)) > 1e-6)
%       error('(ZNKBASISOSADVEC)');
%   end
  

return

